---
title: WebGLRenderingContext.scissor()
slug: Web/API/WebGLRenderingContext/scissor
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.scissor()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> sets a scissor box, which limits the drawing to a specified rectangle.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var><em>void gl</em>.</var>scissor<var>(x, y, width, height);</var>
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>x</code></dt>
 <dd>A {{domxref("GLint")}} specifying the horizontal coordinate for the lower left corner of the box. Default value: 0.</dd>
 <dt><code>y</code></dt>
 <dd>A {{domxref("GLint")}} specifying the vertical coordinate for the lower left corner of the box. Default value: 0.</dd>
 <dt>width</dt>
 <dd>A non-negative {{domxref("Glsizei")}} specifying the width of the scissor box. Default value: width of the canvas.</dd>
 <dt>height</dt>
 <dd>A non-negative {{domxref("Glsizei")}} specifying the height of the scissor box. Default value: height of the canvas.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>If either <em>width</em> or <em>height</em> is a negative value, a <code>gl.INVALID_VALUE</code> error is thrown.</p>

<h2 id="Examples">Examples</h2>

<p>When the scissor test is enabled, only pixels within the scissor box can be modified by drawing commands.</p>

<pre class="brush: js">// turn on scissor test
gl.enable(gl.SCISSOR_TEST);

// set the scissor rectangle
gl.scissor(x, y, width, height);

// execute drawing commands in the scissor box (e.g. clear)

// turn off scissor test again
gl.disable(gl.SCISSOR_TEST);
</pre>

<p>To get the current scissor box dimensions, query the <code>SCISSOR_BOX</code> constant which returns an {{jsxref("Int32Array")}}.</p>

<pre class="brush: js">gl.scissor(0, 0, 200, 200);
gl.getParameter(gl.SCISSOR_BOX);
// Int32Array[0, 0, 200, 200]</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.4", "scissor")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glScissor.xml", "glScissor")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.scissor")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.viewport()")}}</li>
 <li>{{domxref("WebGLRenderingContext.enable()")}}</li>
 <li>{{domxref("WebGLRenderingContext.disable()")}}</li>
</ul>
